// $Author: jmcdanie $
// $Date: 1995-06-12 22:06:14 $
// $Source: /root/cvs/Rigi/rigiedit/adt/numtype.C,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

#ifndef NUMTYPEH
#include "numtype.h"
#endif

NumType::NumType() {
	value = 0;
}

NumType::NumType(unsigned set) {
//	cerr << "creating number.\n";
 	value = set;
}

NumType::NumType(NumTypePtr oldnum) {
//	cerr << "creating numacter string.\n";
 	value = oldnum->value;
}

NumType::~NumType() {
//	cerr << "Deleting NumType.\n";
}

RigiBool NumType::operator==(const NumType& a) const {
//	cerr << "Checking to see if this Object is equal to another.\n";
	return((RigiBool)(value == a.value));
}	

void NumType::operator=(const NumType& a) {
	value = a.value;
}
 
int NumType::Printout(int a) const {
	cerr << value  <<" ";
	return(a + 11); 
}

unsigned int NumType::Hash() const {
	return value;
}


RigiBool NumType::isEqual(void* a) const {
	return ((RigiBool)(*this==*(NumTypePtr)a));
}

void* NumType::Duplicate() 
{
	NumTypePtr tmp = new NumType();
 	*tmp = *this;
	return((void*) tmp);
}

void NumType::Delete_type(ObjectPtr a) {
 	delete ((NumTypePtr) a);
}






// ------------------------------------------------------------------------
//
// $Log: not supported by cvs2svn $
//   Revision 1.1  1994/06/30  20:09:12  bcorrie
//   Initial revision
//
//

