// $Author: jmcdanie $
// $Date: 1995-06-12 22:24:06 $
// $Source: /root/cvs/Rigi/rigiedit/adt/stack.h,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

#ifndef STACKH
#define STACKH

#ifndef ARRAYOBIDH
#include "array.h"
#endif

class Stack;
typedef Stack* StackPtr;

class Stack : public Array {
	int	top;
    public:
   // Routines to initialize and destroy the class.
	Stack(unsigned int size = CLTN_DEFAULT_CAPACITY);
	Stack(const Stack&);
	~Stack() {}

    // Functions that are Required to Use this Class as an Object

   		// .... all routines the same as in Class Array.......

   // Routines that are required by a Collection class and derived classes
   // of Collections. [See Array Class for these routines.]

   	virtual unsigned int Size() const {return (top + 1);}

   		// .... all routines the same as in Class Array.......

   // Routines specific to this class
	void		operator=(const Stack&);
	RigiBool 		operator==(const Stack&) const;
	void		Push(ObjectPtr ob) { Array::Add(++top,ob); }
	ObjectPtr	Pop();
	ObjectPtr	Peek();
	RigiBool		Empty() {return ((RigiBool)(top < 0));}

};
	
#endif

// ------------------------------------------------------------------------
//
// $Log: not supported by cvs2svn $
//   Revision 1.2  1994/06/30  17:41:03  bcorrie
//   Fixed up RCS header stuff
//
//

