// $Author: jmartin $
// $Date: 1996-10-19 18:53:06 $
// $Source: /root/cvs/Rigi/rigiedit/adt/tokentype.h,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

// This may look like C code, but it is really -*- C++ -*-

#ifndef TOKENTYPEH
#define TOKENTYPEH
#ifndef STREAMH
#include <stream.h>
#endif
#ifndef OBJECTH
#include "object.h"
#endif
#ifndef	NullS
#include "strings++.h"
#endif
#ifndef CHARTYPEH
#include "chartype.h"
#endif

class TokenType;
typedef TokenType* TokenTypePtr;

class TokenType : private RigiObject {
	CharType 	name;
	CharType	typeName;
	int		index;     
    public:
	TokenType();
	TokenType(char*,int);
	TokenType(char*);
	TokenType(TokenType&);

	~TokenType();
	void Assign(char*,int);
	void SetName(char* a);
	void SetTypeName(char*);
	void SetIndex(int i);
	char* Name() const;
	char* TypeName() const;
	int Index() const;

	RigiBool operator==(const TokenType& a) const;
	void operator=(const TokenType& a);

   // Routines that are required by a Object class and derived classes of 
   // Objects
	virtual int Printout(int) const ;
	virtual unsigned int Hash() const;                 
	virtual RigiBool isEqual(void* a) const; 
	virtual void* Duplicate() {return NULL;}
	virtual void* Create() {return NULL;}
	virtual void  Delete_type(ObjectPtr) {}

};

#endif

// ------------------------------------------------------------------------
//
// $Log: not supported by cvs2svn $
//   Revision 1.3  1995/06/12  22:24:07  jmcdanie
//   PC port
//
//   Revision 1.2  1994/06/30  17:41:06  bcorrie
//   Fixed up RCS header stuff
//
//

