//
// File:    cl_activearc.h
// Author:  Brian Corrie
// Date:    January 16, 1991
// Project: Rigi V4.0
//

// $Author: jmcdanie $
// $Date: 1996-03-21 02:39:34 $
// $Source: /root/cvs/Rigi/rigiedit/cl_activearc.h,v $
// $Locker:  $
// $State: Exp $

//------------------------------------------------------------------------

#ifndef ACTIVEARC_H
#define ACTIVEARC_H

#ifndef LIST_H
#include "cl_list.h"
#endif

class RigiWindow;
class RigiArc;

class ActiveArc : private SimpleList // RigiArcs associated with an arc
{
public:

    ActiveArc();
    ~ActiveArc();

    void     AddArc( RigiArc* r )    { Insert((Info*)r); }
    RigiArc* RemoveArc( RigiArc* r ) { return (RigiArc*)Remove((Info*)r); }
    void DrawAll();
    RigiArc* FindRigiArc( RigiWindow* );
};

#endif

