//
/*
* Re-definition of C constructs for better readability
*/
//

// $Author: jmcdanie $
// $Date: 1996-03-21 02:39:42 $
// $Source: /root/cvs/Rigi/rigiedit/constructs.h,v $
// $Locker:  $
// $State: Exp $

//------------------------------------------------------------------------

#ifndef CONSTRUCTS_H
#define CONSTRUCTS_H

/*
*    FOR ( expr ; expr ; expr )
*        stmt;
*        stmt;
*    ENDFOR
*/
#define FOR(x)    for(x) {
#define ENDFOR    };

/*
*    IF ( expr )
*        stmt;
*        stmt;
*    ELSEIF ( expr )
*        stmt;
*        stmt;
*    ELSE
*        stmt;
*        stmt;
*    ENDIF
*/

#define IF(x)        if(x) {
#define ELSE        } else {
#define ELSEIF(x)    } else if(x) {
#define ENDIF        };

/*
*    WHILE ( expr )
*        stmt;
*        stmt;
*    ENDWHILE
*/
#define WHILE(x)    while(x) {
#define ENDWHILE    };

/*
*    SWITCH ( expr )
*        CASE ( constant )
*            stmt;
*            stmt;
*        ENDCASE
*
*        CASE ( constant )
*            stmt;
*            stmt;
*        <<drop through to next case>>
*
*        CASE ( constant )
*            stmt;
*            stmt;
*        ENDCASE
*
*        DEFAULT
*            stmt;
*            stmt;
*        ENDCASE
*    ENDSWITCH
*/
#define SWITCH(x)    switch(x) {
#define ENDSWITCH    };
#define CASE( const )    case const :
#define ENDCASE        break;
#define DEFAULT        default :

/*
*    REPEAT
*        stmt;
*        stmt;
*    UNTIL ( expr )
*/
#define REPEAT        do {
#define UNTIL(x)    } while( !(x) );

#endif

