
// $Author: jmcdanie $
// $Date: 1996-05-26 18:13:04 $
// $Source: /root/cvs/Rigi/rigiedit/scaleops.C,v $
// $Locker:  $
// $State: Exp $

//------------------------------------------------------------------------
#ifndef WINUTIL_H
#include "win_util.h"
#endif

#ifndef RIGISTATE_H
#include "cl_rigistate.h"       // Global instance of editor's state
#endif
#ifndef GLOBAL_H
#include "global.h"
#endif
#ifndef RIGIWINDOW_H
#include "cl_rigiwindow.h"
#endif
#ifndef RIGIUTIL_H
#include "rigiutil.h"
#endif
#ifndef SCALEOPS_H
#include "scaleops.h"
#endif
#ifndef RIGIERR_H
#include "rigierr.h"
#endif

int ScaleOp(int arg, char **argv, CharType &result) {
    WindowSetCursor( CURSOR_WAIT );
    RigiWindow* rw = RutilActiveWindow();

    switch (atoi(argv[1])) {
    case SCALEWIN:
        rw->ScaleToView();
        break ;
    case SCALEBOX:
        rw->ScaleSelect();
        break ;
    case SCALEFACTOR:
        rw->ScaleFactor();
        break ;
    case SCALEUNSCALE:
        rw->ScaleUnscale();
        break ;
    default: 
        WindowSetCursor( CURSOR_NORMAL );
        return RigiError(ERRORFLAG, "Unknown scale operation (%s)", argv[1]);
    }
    rw->RigiDisplay() ;
    WindowSetCursor( CURSOR_NORMAL );
    return 1;
}
