//
// dialog.h - Declarations for the dialog windows.
//

// $Author: jmcdanie $
// $Date: 1996-04-30 23:11:21 $
// $Source: /root/cvs/Rigi/rigiedit/tk_dialog.h,v $
// $Locker:  $
// $State: Exp $

//------------------------------------------------------------------------

#ifndef DIALOG_H
#define DIALOG_H

// Set of enumerated types for control windows

typedef enum {
    CONTROL, COLOR, REGEXP, FILEDIALOG, ARCTREE,
    EXACT, VIEWED, ARCTHRESH, LISTER
} RigiDialogType;

// Class declarations

class RigiColorMap;
class ControlDialogWindow;
class TextswEditorWindow;

// Interaction windows

extern RigiColorMap*          rigi_colormap;  // Rigi color map
extern ControlDialogWindow*   controlpanel;   // Control panel window
extern TextswEditorWindow*    exactface;      // Exact interface window

// Access functions to control dialogs.

extern void DialogUpdate();
extern void DialogDestroy();
extern void DialogDelete();
extern void DialogCreate( RigiDialogType );
extern int  DialogActive( RigiDialogType );
extern void DialogInit();


#endif

