 

 


 
 

 







 


 


typedef unsigned long	size_t;

typedef long	fpos_t;

 




 




typedef struct {
	unsigned char	*_ptr;
	int	_cnt;
	unsigned char	*_base;
	unsigned char   *_bufendp;
	short	_flag;
	short	_file;
	int	__stdioid;
	char	*__newbase;
	long	_unused[1];
} FILE;

extern FILE	_iob[16];


extern size_t 	fread(void *, size_t, size_t, FILE *);
extern size_t	fwrite(const void *, size_t, size_t,FILE *);


extern int	__flsbuf(unsigned char, FILE *);
extern int	__filbuf(FILE *);
extern int 	ferror(FILE *);
extern int 	feof(FILE *);
extern void 	clearerr(FILE *);
extern int 	putchar(int);
extern int 	getchar(void);
extern int 	putc(int, FILE *);
extern int 	getc(FILE *);
extern int	remove(const char *);
extern int	rename(const char *, const char *);
extern FILE 	*tmpfile(void);
extern char 	*tmpnam(char *);
extern int 	fclose(FILE *);
extern int 	fflush(FILE *);
extern FILE	*fopen(const char *, const char *);
extern FILE 	*freopen(const char *, const char *, FILE *);
extern void 	setbuf(FILE *, char *);
extern int 	setvbuf(FILE *, char *, int, size_t);
extern int	fprintf(FILE *, const char *, ...); 
extern int	fscanf(FILE *, const char *, ...);
extern int	printf(const char *, ...); 
extern int	scanf(const char *, ...); 
extern int	sprintf(char *, const char *, ...); 
extern int	sscanf(const char *, const char *, ...); 

 


 

 

typedef char *__va_list;

extern int	vfprintf(FILE *, const char *, __va_list);
extern int	vprintf(const char *, __va_list); 
extern int	vsprintf(char *, const char *, __va_list);

extern int 	fgetc(FILE *);
extern char 	*fgets(char *, int, FILE *);
extern int 	fputc(int, FILE *);
extern int 	fputs(const char *, FILE *);
extern char 	*gets(char *);
extern int 	puts(const char *);
extern int	ungetc(int, FILE *);
extern int	fgetpos(FILE *, fpos_t *);
extern int 	fseek(FILE *, long int, int);
extern int	fsetpos(FILE *, const fpos_t *);
extern long	ftell(FILE *);
extern void	rewind(FILE *);
extern void 	perror(const char *); 







 

 
 
 



 

 

typedef int		ptrdiff_t;

typedef unsigned short	wchar_t;

typedef unsigned int	wctype_t;


typedef	long		time_t;

typedef int		clock_t;



 
typedef	unsigned char	uchar_t;
typedef	unsigned short	ushort_t;
typedef	unsigned int	uint_t;
typedef unsigned long	ulong_t;
typedef signed int	ssize_t;

 
typedef long		level_t;
typedef	long		daddr_t;	 
typedef	char *		caddr_t;	 
typedef	ulong_t		ino_t;		 
typedef short		cnt_t;
typedef ulong_t		dev_t;		 
typedef	long		chan_t;		 
typedef	long		off_t;		 
typedef	long		paddr_t;
typedef	long		key_t;
typedef long		timer_t;	 
typedef	short		nlink_t;
typedef	ulong_t		mode_t;		 
typedef ulong_t		uid_t;		 
typedef ulong_t		gid_t;		 
typedef	void *		mid_t;		 
typedef	int		pid_t;		 
typedef int             tid_t;           
typedef char		slab_t[12];	 
typedef long            mtyp_t;		 
typedef int             boolean_t;

	typedef	int		wint_t;		 

typedef ulong_t		id_t;		 

 
 
typedef struct sigset_t	{
	unsigned long losigs;
	unsigned long hisigs;
} sigset_t;

typedef int signal_t;



 
 



typedef struct label_t {		 
	struct label_t *prev;		 
	ulong_t           iar;		 
	ulong_t           stack;		 
	ulong_t           toc;		 
	ulong_t           cr;              
	ulong_t           intpri;		 
	ulong_t           reg[19];	 
} label_t;

typedef long		vmid_t;		 
typedef ulong_t		vmhandle_t;	 

typedef struct vmaddr_t {		 
	vmhandle_t	srval;		 
	caddr_t		offset;		 
} vmaddr_t;

typedef struct adspace_t{		 
	ulong_t		alloc;		 
	vmhandle_t	srval[16];	 
} adspace_t;






 
typedef ushort_t	UniChar;

 
typedef	uchar_t		uchar;
typedef	ushort_t	ushort;
typedef	uint_t		uint;
typedef ulong_t		ulong;

typedef	struct { int r[1]; } *	physadr_t;
typedef	physadr_t	physadr;

 
typedef	unsigned char	u_char;
typedef	unsigned short	u_short;
typedef	unsigned int	u_int;
typedef	unsigned long	u_long;

typedef	struct	_quad { long val[2]; } quad;
typedef	long	swblk_t;


 
struct sigset	{
	unsigned long losigs;
	unsigned long hisigs;
};

 
struct fsid {
	long	val[2];
};
typedef struct fsid fsid_t;

 

struct fid {
	uint_t	fid_len;
	char	fid_data[(32 - sizeof(fsid_t) - sizeof(uint_t))];
};
typedef struct fid fid_t;

struct fileid {			 
	uint_t	fid_len;
	ino_t	fid_ino;
	uint_t	fid_gen;
	char	fid_x[(32 - sizeof(fsid_t) - sizeof(uint_t)) - (sizeof(ino_t) + 2) - sizeof(uint_t)];
};

 
struct fhandle {
	char x[32];		 
};
struct filehandle {			 
	fsid_t		fh_fsid;		 
	struct fileid	fh_fid;			 
};
typedef struct fhandle fhandle_t;

 
struct unique_id {
       unsigned long word1;
       unsigned long word2;
       unsigned long word3;
       unsigned long word4;
};
typedef struct unique_id unique_id_t;


typedef	long long  offset_t;		 



extern int 	fileno(FILE *);
extern FILE 	*fdopen(int,const char *);
extern char	*ctermid(char *);




 


 

 

typedef __va_list va_list;


extern	char	*optarg;
extern	int	opterr;
extern	int	optind;
extern	int	optopt;


extern int 	getw(FILE *);
extern int 	putw(int, FILE *);
extern char 	*tempnam(const char*, const char*);
extern FILE 	*popen(const char *, const char *);
extern int 	pclose(FILE *);
extern int	getopt(int, char * const [], const char*);
extern char 	*cuserid(char *);



 
 



 

 




 

 



 



 


 

 




 

 

 





 

 

 



 









 


 


 


 





 




	extern  unsigned   int SINFINITY;
	extern  unsigned   int _DBLINF[2];
	extern  unsigned   int SQNAN;
	extern  unsigned   int DQNAN[2];
	extern  unsigned   int SSNAN;
	extern  unsigned   int DSNAN[2];



 

typedef	unsigned short fprnd_t;


fprnd_t fp_read_rnd(void);
fprnd_t fp_swap_rnd(fprnd_t rnd);



 



			 

 


 












					 
					 


 


 


 

  


extern void setbuffer(FILE *, char *, size_t);
extern void setlinebuf(FILE *);


			 
  			 

			 
			 
			 
			 

 





typedef struct element Element;

extern Element* elementcreate();
extern Element* elementnext();
extern void     elementsetnext();
extern int      elementinfo();

typedef struct list
{
    int      id;
    Element* where;
    Element* first;
} List;

extern List*    listcreate();
extern void     listinit();
extern int      listid();
extern Element* listfirst();
extern void     listinsert();
extern Element* listnext();

extern char* malloc();

struct element 
{
    Element* next;
    int      info;
};

Element* elementcreate(i)
    int i;
{
    Element* elem = (Element*)malloc(sizeof(Element));
    if (elem == 0)
    {
        fprintf((&_iob[2]),"elementcreate: malloc failed, out of memory???\n");
        return 0;
    }

    elem->next = 0;
    elem->info = i;
    return elem;
}

int elementinfo(e)
    Element* e;
{
    if (e == 0) return 0;
    return e->info;
}

Element* elementnext(e)
    Element* e;
{
    if (e == 0) return 0;
    return e->next;
}

void elementsetnext(e,n)
    Element *e,*n;
{
    if (e == 0) return;
    e->next = n;
}
