// $Author: jmartin $
// $Date: 1997-12-05 01:57:18 $
// $Source: /root/cvs/Rigi/rigiedit/UT/src/pmdb.h,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

#ifndef PMDB_H
#define	PMDB_H

extern int LoadRSF( const char *filename );
extern int LoadSexp( const char *filename );
extern int SaveSexp( const char *filename );

extern void DumpNames();
extern void EmptyPMDB();

extern const char *MakeSexp( const char *s, int tml_flag=0 );
extern const void ParseSexp( const char *s );
extern void ForAllObjects( int (*)(const char*) );
extern void ForEachObject
	( const char* name, const char* attr, int (*f)(const char*) );

#endif

// ------------------------------------------------------------------------
//
// $Log: not supported by cvs2svn $
//   Revision 1.5  1995/10/29  18:58:36  mwhitney
//   let the loading and saving routines return a value
//   indicating success
//
//   Revision 1.4  1995/10/27  18:45:44  mwhitney
//   *** empty log message ***
//
//   Revision 1.3  1994/10/04  22:02:42  mwhitney
//   more protos
//
//   Revision 1.2  1994/08/26  18:39:32  mwhitney
//   Added Load/SaveSexp
//
//   Revision 1.1  1994/08/17  20:48:12  mwhitney
//   Initial revision
//
//
