// $Author: jmcdanie $
// $Date: 1995-06-12 22:24:04 $
// $Source: /root/cvs/Rigi/rigiedit/adt/numlist.h,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

#ifndef NUMLISTH
#define NUMLISTH

#ifndef HASHTBLH
#include "hash.h"
#endif
#ifndef NUMTYPEH
#include "numtype.h"
#endif

class NumList;
typedef NumList* NumListPtr;

class NumList : public HashTbl {
    public:
   // Routines to initialize and destroy the class.
	NumList(unsigned int size = CLTN_DEFAULT_CAPACITY);
	~NumList(); 

    // Functions that are Required to Use this Class as an Object

   		// .... all routines the same as in Class List.......

   // Routines that are required by a Collection class and derived classes
   // of Collections. [See List Class for these routines.]

   		// .... all routines the same as in Class List.......

   // Routines specific to this class
	NumTypePtr Create(unsigned);
	RigiBool Add(NumTypePtr);
   	RigiBool Includes(unsigned);
	RigiBool Remove(unsigned int, unsigned int&);
  	void operator=(const NumList&);
  	RigiBool operator==(const NumList&);
        void operator&(const NumList&);
        void operator|(const NumList&);
        void operator-(const NumList&);
	
};
	
#endif

// ------------------------------------------------------------------------
//
// $Log: not supported by cvs2svn $
//   Revision 1.2  1994/06/30  17:41:00  bcorrie
//   Fixed up RCS header stuff
//
//

