// $Author: jmcdanie $
// $Date: 1995-06-12 22:24:05 $
// $Source: /root/cvs/Rigi/rigiedit/adt/numtype.h,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

#ifndef NUMTYPEH
#define NUMTYPEH

#ifndef STREAMH
#include <stream.h>
#endif
#ifndef OBJECTH
#include "object.h"
#endif


/* ======================================================================  */
	
class NumType;
typedef NumType* NumTypePtr;

class NumType : private RigiObject {
	unsigned value;
    public:
	NumType();
	NumType(unsigned);
	NumType(NumTypePtr);
	~NumType();
	void Assign(unsigned a) {value = a;}
	unsigned Value() {return value;}
	RigiBool operator==(const NumType& a) const;
	void operator=(const NumType& a);

   // Routines that are required by a Object class and derived classes of 
   // Objects
	virtual int Printout(int) const;
	virtual unsigned int Hash() const;                 
	virtual RigiBool isEqual(void* a) const;
	virtual void* Duplicate();
	virtual void* Create() { return ((void*) new NumType); }
	virtual void  Delete_type(ObjectPtr);

};

#endif

// ------------------------------------------------------------------------
//
// $Log: not supported by cvs2svn $
//   Revision 1.2  1994/06/30  17:41:02  bcorrie
//   Fixed up RCS header stuff
//
//

