//
// $Author: jmartin $
// $Date: 1998-10-05 20:12:45 $
// $Source: /root/cvs/Rigi/rigiedit/cl_base_window.C,v $
// $Locker:  $
// $State: Exp $

const static char rcsid[] = "$Id: cl_base_window.C,v 1.17 1998-10-05 20:12:45 jmartin Exp $";

//------------------------------------------------------------------------

#ifndef STREAMH
#include <stream.h>
#endif
#include <math.h>
#ifndef __STRING_H
#include <string.h>
#endif

#ifndef BASEWINDOW_H
#include "cl_base_window.h"  // Include the class definition
#endif
#ifndef GRAPHERR_H
#include "grapherr.h"        // Include for error routine Mess/mayday/warn
#endif

// Last id generated for a window. We assume this won't wrap around....
static int id_count = 0;

BaseWindow::BaseWindow(char *typestr)
{
    type = new char[strlen(typestr)+1];
    strcpy(type, typestr);
    id = ++id_count;
    redrawCnt = numDrawObj = 0;
}

BaseWindow::BaseWindow(BaseWindow& win)
{
    type = new char[strlen(win.type)+1];
    strcpy(type, win.type);
    id = id_count++;
    redrawCnt = numDrawObj = 0;
}


BaseWindow::~BaseWindow()
{
    delete[] type;
}

char* BaseWindow::GetType()
{
    return type;
}

int BaseWindow::OfType( char* t )
{
    return ( strcmp(type, t) == 0 );
}

int BaseWindow::GetId()
{
    return id;
}
