//
// File:    graphnodelist.h
// Author:  Brian Corrie
// Date:    January 17, 1991
// Project: Rigi V4.0
//

// $Author: jmcdanie $
// $Date: 1996-03-21 02:39:38 $
// $Source: /root/cvs/Rigi/rigiedit/cl_graphnodelist.h,v $
// $Locker:  $
// $State: Exp $

//------------------------------------------------------------------------

#ifndef GRAPHNODELIST_H
#define GRAPHNODELIST_H

#ifndef LIST_H
#include "cl_list.h"            // List class definitions
#endif

class GraphNode;


class NodeList : private List
{
public:

    NodeList() {}
    ~NodeList() {}

    void       Insert(GraphNode*n) { List::Insert((GraphNode*)n); }
    void       Empty()             { List::Empty(); }
    int        GetNoItems()        { return List::GetNoItems(); }

    GraphNode* First()             { return (GraphNode*)List::First(); }
    GraphNode* Next()              { return (GraphNode*)List::Next(); }
};

#endif
