#!/bin/sh

# This configure file should work for host cedar.
# $Id: config.cedar.sh,v 1.1 2002-03-04 22:40:05 kienle Exp $


TCLVER=8.4
TKVER=8.4

TCLDIR=/usr/local
TKDIR=/usr/local

TCLINC=$TCLDIR/tcl$TCLVER/generic
TKINC=$TKDIR/tk$TKVER/generic
TCLTCL=$TCLDIR/tcl$TCLVER/lib/tcl$TCLVER
TKTCL=$TKDIR/tk$TKVER/lib/tk$TKVER
TCLLIB=$TCLDIR/tcl$TCLVER/unix/libtcl$TCLVER.a
TKLIB=$TKDIR/tk$TKVER/unix/libtk$TCLVER.a

if [ -f ./configure ] ; then
    CONFIGURE=./configure
else
    CONFIGURE=../configure
fi

$CONFIGURE $PREFIX --enable-gcc --with-tclinc=$TCLINC --with-tcllib=$TCLLIB --with-tcltcl=$TCLTCL --with-tkinc=$TKINC --with-tklib=$TKLIB --with-tktcl=$TKTCL $EXTRA $*
