// $Author: jmartin $
// $Date: 1996-10-19 18:40:06 $
// $Source: /root/cvs/Rigi/rigiedit/grapherr.C,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

#include <stdio.h>

#ifndef STREAMH
#include <stream.h>
#endif
#ifndef __string_h
#include <string.h>     // strlen, strcmp
#endif
#include <stdarg.h>	// for varargs stuff

#ifndef _CCHEADER_H_
#include "CCheader.h"	// RigiBool
#endif
#ifndef RIGIERR_H
#include "rigierr.h"    // Alert
#endif

extern char *progname;
extern RigiBool VERBOSE;

void mayday( char* format ... )
{
    va_list ap;
    va_start( ap, format );
    fprintf(stderr,"%s error: ",progname ) ;
    vfprintf( stderr, format, ap );
    fprintf(stderr,"\n" );
    va_end(ap);
}

void warn( char *format ... )
{
    va_list ap;
    va_start( ap, format );
    fprintf(stderr,"%s alert: ",progname );
    vfprintf( stderr, format, ap );
    fprintf(stderr,"\n" );
    va_end(ap);
}

void Mess( char *format ... )
{
    static int i=0;
    if (!VERBOSE) return;

    va_list ap;
    va_start( ap, format );
    if (i==0) fprintf(stderr,"%s: ",progname );
        else i=0;
    if (format) vfprintf( stderr, format, ap );
    if (!format || strcmp(format+strlen(format)-4,"... "))
        fprintf(stderr,"\n" );
    else i=1;
    va_end(ap);
}

