
// $Author: kienle $
// $Date: 2002-03-01 02:15:34 $
// $Source: /root/cvs/Rigi/rigiedit/infoops.h,v $
// $Locker:  $
// $State: Exp $

// const static char rcsid[] = "$Id: infoops.h,v 1.21 2002-03-01 02:15:34 kienle Exp $";

//------------------------------------------------------------------------

#ifndef INFOOPS_H
#define INFOOPS_H 

const int GETNODENAME       = 0; 
const int GETNODEPOSITION   = 1;
const int GETNODEABSPOSITION    = 33;
const int GETNODESIZE       = 2;
const int GETNODETYPE       = 3;
const int GETNODEATTR       = 4;
const int GETNODEID         = 5;
const int GETNODEINWINDOW   = 6;
const int GETNODENAMEISHIDDEN = 19;

const int SETNODENAME       = 7; 
const int SETNODEPOSITION   = 8;
const int SETNODEABSPOSITION    = 32;
const int SETNODETYPE       = 9;
const int SETNODEATTR       = 10;

const int GETNODEATTRS      = 11;
const int GETNODEFIRSTATTR  = 12;
const int GETNODENEXTATTR   = 13;
const int GETNODENUMATTRS   = 14;

const int FILTERNODE        = 15;
const int UNFILTERNODE      = 16;
const int GETNUMARCS        = 17;
const int GETNODESELECTED   = 18;

const int GETARCNAME        = 20;
const int GETARCSRC	        = 21;
const int GETARCDST         = 22;
const int GETARCTYPE        = 23;
const int GETARCATTR        = 24;
const int GETARCID          = 25;

const int SETARCNAME        = 27;
const int SETARCTYPE        = 28;
const int SETARCATTR        = 29;

const int GETARCCOLOR       = 34;
const int SETARCCOLOR       = 35;
const int GETNODECOLOR      = 36;
const int SETNODECOLOR      = 37;
const int WRITECOLORS       = 38;
const int GETNODEBITMAP     = 39;
const int REMOVENODEATTR    = 40;
const int REMOVEARCATTR     = 41;

const int GETARCFIRSTATTR   = 42;
const int GETARCNEXTATTR    = 43;
const int GETARCNUMATTRS    = 44;

const int SETNEW            = 51;
const int SETADD            = 52;
const int SETREMOVE         = 53;
const int SETFIND           = 54;
const int SETEMPTY          = 55;
const int SETFIRST          = 56;
const int SETSIZE           = 57;

const int GETENVIRON        = 61;
const int SETENVIRON        = 62;
const int PRINTENVIRON      = 63;

const int GETVERSION        = 70;
const int GETSHIFTED        = 71;

static inline int IS_SET_OP( int o ) { return o>50&&o<58; }
static inline int IS_ENV_OP( int o ) { return o>60&&o<64; }
static inline int IS_NODE_OP( int o ) { return o<20||o==32||o==33||o==40; }

extern const char* InfoOp( int op, int id, char* name, char* attr );

#endif

