//
//

// $Author: jmartin $
// $Date: 1999-07-18 03:40:43 $
// $Source: /root/cvs/Rigi/rigiedit/tidysys.h,v $
// $Locker:  $
// $State: Exp $

//------------------------------------------------------------------------

#ifndef TIDYSYS_H
#define TIDYSYS_H

/*
* general system definitions
*/

/*
* storage classes
*/
#define    EXPORT
#define    IMPORT    extern
#define PRIVATE    static
#define REG    register

/*
* The boolean type is defined as an int rather than an enumerated
* type to allow tests such as "if ( b ) ...", and assignments such 
* as "b = (boolean) x == y", where b is boolean, x and y arbitrary.
* This means that boolean objects should never be tested against
* TRUE or FALSE directly.  These value are to be used only in direct
* assignments (i.e. b = TRUE).
*/
//typedef    int    boolean;
#ifndef TRUE
#define TRUE    1
#endif
#ifndef FALSE
#define FALSE    0
#endif

#ifndef NULL
#define    NULL    0
#endif

/* integer types */
typedef long int        int32;
typedef short int        int16;
typedef unsigned long int    uint32;
typedef unsigned short int    uint16;

/* string types */
#define MAX_STR_LEN    80
typedef    char    string[ MAX_STR_LEN ];

#endif

