
// $Author: jmcdanie $
// $Date: 1996-07-10 16:17:52 $
// $Source: /root/cvs/Rigi/rigiedit/win_util.h,v $
// $Locker:  $
// $State: Exp $

//------------------------------------------------------------------------

#ifndef WINUTIL_H
#define WINUTIL_H

#ifndef _CCHEADER_H_
#include "CCheader.h"
#endif
#ifndef TKCOLORMAP_H
#include "tk_colormap.h"
#endif
class GraphNode;
class RigiWindow;

// Line width sizes
extern	int SMALL;		// variable, for different X versions
extern int BIG;
extern int THICK;

// Cursor types
extern int CURSOR_NORMAL ;
extern int CURSOR_WAIT ;

// Base windowing object access functions

extern void           WindowDestroyAll();
extern void           WindowSetCursor(int) ;
extern int            WindowIsShifted();
extern int            WindowTextEdit(GraphNode*);
extern RigiBool       WindowForegroundColor(RigiColor *col);
extern RigiBool       WindowBackgroundColor(RigiColor *col);

#endif

